// Zoom
// by REAS <http://www.groupc.net>

// Move the cursor over the image to alter its position. Click and press
// the mouse to zoom and set the density of the matrix by typing numbers 1-5.
// This program displays a series of lines with their heights corresponding to 
// a color value read from an image. 

// Created 10 August 2002

BImage a;

boolean onetime = true;

//array de pixels da imagem
int[][] aPixels;

//valor de zoom ( scale )
float sval = 0.02;

float nmx, nmy;

//mouse positions
int lastMouseX,secondMouseX;

//Image dimensions
int iWidth=640;
int iHeight=480;


//resoluao original
int res = 3;


int pixelPos;

float fs=0;

void setup() 
{
  
  lastMouseX=mouseX;
  size(640,480);
  noFill();
  stroke(255);
  //alocando memoria para os pixels  
  aPixels = new int[iWidth][iHeight];
  
  //carregando a imagem
  a = loadImage("foto.jpg");
  
  image(a, 0, 0);
  //carrega os pixels da imagem nos pixels criados
   for(int i=0; i<height; i++) {
    for(int j=0; j<width; j++) {
      aPixels[j][i] = a.pixels[i*width+j];
    }
  }
  noCursor(); 
}

void loop() 
{
  background(0);

  if (abs(mouseX - nmx) > 1.0) {
    nmx = nmx + (mouseX-nmx)/10;
  }
  if (abs(mouseY - nmy) > 1.0) {
    nmy += (mouseY-nmy)/10;
  }

  if(mousePressed) {
    sval += 0.02;
  } else {
    sval -= 0.05;
  }
if(sval > 1.9) { sval = 1.9; }
if(sval < 0.5) { sval = 0.5; }

//if(!mousePressed){
  //translate(width/2+nmx*sval-130, height/2+nmy*sval-100, -50);
//}
//else{
  translate(width/2+nmx*sval-(220*sval), height/2+nmy*sval-(200*sval), -50);
//}
scale(sval);
  //rotateZ(PI/9-sval+1.0);
  //rotateX(PI/sval/8-0.125);
  //println("mouseY="+mouseY);
  if(mouseY>280){
    rotateX(fs);
     fs+=(0.01+(float)(100+mouseY)/10000); 
     if(fs>6.25){fs=0;}
     //println(fs);   
    // println("rodando co mouse maior" );
  }
  else if(mouseY<200){
    //rotateX(fs);
    fs-=(0.01+(float)(100+height-mouseY)/10000);
    rotateX(fs);
    // println(fs); 
    if(fs<-6.25){fs=0;}
    //println("rodando co mouse menor" );
  }
  else{
    rotateX(fs);
    
    if(fs<0){
     //println("fs+1"+fs+(0.01+(float)(100+mouseY)/10000) );
      if(fs+(0.01-(float)(100-mouseY)/1000)>0){
        fs=0;
        //println("parando o fs>0" );
      }
      else{
        fs+=(0.01-(float)(100-mouseY)/1000);
         //println("diminuindo menor zero" );
      }
    }
    
    else if(fs>0){
      if(fs-(0.01-(float)(100-mouseY)/10000)<0){
        fs=0;
          //println("parando o fs<0" );
      }
      else{
        fs-=(0.01-(float)(100-mouseY)/1000);
        //println("diminuindo maior zero" );
      }
    }
    
    
  }
  translate(-width/2, -height/2, 0);

  int rc=0;
  //alterado para imprimir cores corretas
  //qualquer modificaao alterar os valores rr gg ou bb
  //ou criar uma cor modifica utilizando a funcao stroke
  float rr, gg, bb, tt;
  for(int i=0; i<iWidth; i+=res) {
    for(int j=0; j<iHeight; j+=res) {
      rr = red(aPixels[i][j]);
      gg = green(aPixels[i][j]);
      bb = blue(aPixels[i][j]);
      tt = rr+gg+bb;
      //possiveis alteracores
      //      stroke(rr, gg, gg);  
      //      stroke(rr, bb, bb);  
      stroke(rr, gg, bb);  
      line(i, j, tt/10-20, i, j, tt/10 );
      rc++;
    }
  }

  
}

void keyPressed() {
  if(key == '1') {
    res = 1;
  } else if (key == '2') {
    res = 2; 
  } else if (key == '3') {
    res = 3;
  } else if (key == '4') {
    res = 4;
  } else if (key == '5') {
    res = 5;
  }
}






